/************************************************************************
  			include.h - SBMLEvolver - CSB, FSU Jena

This software is free for use and modification, but comes without any
warranty. Usage is entirely at your own risk!

Developers: 	Thorsten Lenser (thlenser@inf.uni-jena.de)
		Jan Huwald (jh@sotun.de)
		Lisa Hellwig (louis-chan@web.de)
		

	$Id: include.h 3 2007-06-04 12:59:46Z thlenser $

This is the central include file, containing instructions and definitions
which should be contained in all other files. It is therefore to be 
included into all other header files.
**************************************************************************/


#ifndef INCLUDE_H_
#define INCLUDE_H_

#include <cstdlib> // for the exit command
#include <iostream> // For error output

#define VERY_BAD_FITNESS 10000000
#define LARGEST_PARAMETER_VALUE 10
#define LARGEST_PARAMETER_STRING "10"
#define LARGEST_INITIAL_CONCENTRATION_VALUE 100
#define LARGEST_INITIAL_CONCENTRATION_STRING "100"

// Exception handling

using namespace std;

#define PL	fprintf(stderr, "passed %s\t:%d\r\n", __FILE__, __LINE__);

#define THROW_WARN(message) \
	cout << "\nWARNING: " << message << "\nIn " << __FILE__ << " " << __LINE__ << endl;

#define THROW_ERROR(message) \
{ cerr << "\nFATAL: " << message << "\nIn " <<  __FILE__ << " " << __LINE__ << endl; \
	exit(EXIT_FAILURE); }	
	

#endif /*INCLUDE_H_*/
