#include "../integrator.h"
#include "../randomnumbergenerator.h"

using namespace sbmlevolver;

namespace sbmlevolver{

class ObjectiveFunction : public ObjectiveFunctionBase{
public:
	/// Default construnctor, may use an input file
	ObjectiveFunction(unsigned long int seed, const char* filename = NULL);
	
	/// Construct the object from a string
	ObjectiveFunction(string, unsigned long int seed = NULL);
	
	/// Destructor
	~ObjectiveFunction();

	/// Get the fitness of a model. Always specify this function!
	double calculateRawFitness(Model*);

private:
	unsigned long int seed;
	Integrator* integrator;
	RandomNumberGenerator* rng;
	
	int getStatusGeneA(integrator_result* res);
	int getStatusGeneB(integrator_result* res);
};

}
