/* Version information
 *
 * $Id: randomnumbergenerator.cpp 3 2007-06-04 12:59:46Z thlenser $
 *
 */


#include "randomnumbergenerator.h"

using namespace std;
using namespace sbmlevolver;

/*RandomNumberGenerator::RandomNumberGenerator()
{
	// Start a random number generator
	// Uses the "Mersenne-Twister" generator from the GSL
	r = gsl_rng_alloc (gsl_rng_mt19937);
	if(r == NULL){
		cerr << "No memory to create random number generator!" << endl;
		exit(EXIT_FAILURE);
	}
	// RNG is now initialised with default seed
	gsl_rng_set(r, (unsigned long int) time(NULL) + getpid());		
}*/

RandomNumberGenerator::RandomNumberGenerator(unsigned long int seed)
{
	// Start a random number generator
	// Uses the "Mersenne-Twister" generator from the GSL
	r = gsl_rng_alloc (gsl_rng_mt19937);
	if(r == NULL){
		cerr << "No memory to create random number generator!" << endl;
		exit(EXIT_FAILURE);
	}
	// RNG is now initialised with default seed, set the new seed
	gsl_rng_set(r, seed);		
}


RandomNumberGenerator::~RandomNumberGenerator()
{
	gsl_rng_free(r);
}

int RandomNumberGenerator::uniform(int min, int max){
	if(min > max){
		cerr << "Min: " << min << " Max: " << max << endl;
		THROW_ERROR("Larger min than max in RandomNumberGenerator");
	}
	return min + gsl_rng_uniform_int(r, max-min+1);
}

double RandomNumberGenerator::uniform(){
	return gsl_rng_uniform(r);
}

double RandomNumberGenerator::gaussian(double mu, double sigma){
	return mu + gsl_ran_gaussian(r, sigma);
}

bool RandomNumberGenerator::challenge(double x){
	if(uniform() < x) return true;
	else return false;
}


/**
 * This function enables the whole program to take its random seeds
 * from the random number generator in paramobj. This way, the whole
 * run only depends on the one random seed given as a command line
 * argument, thus making runs reproducable.
 */
unsigned long int RandomNumberGenerator::getASeed(){
	// HINT: INT_MAX is too large for some rng implementations
	//return rng->uniform(0,INT_MAX);
	return uniform(0, 100000000);
}

